## Script (Python) "getEventServers"
##parameters=
##title=

event = context
if event.meta_type != 'Media Manager Live Event':
    raise 'Attribute Error', 'Not calling this script on a live event'

servers = []
last_encoders = event.getLastEncoder()
for file in event.listFileObjects():
    for logicpath in file.listLogics():
        logic = context.restrictedTraverse(logicpath)
        if logic.meta_type == 'Media Manager Live Server Logic':
            logicset = {}
            logicset['path'] = logic.absolute_url(relative=1)
            logicset['title'] = logic.title
            logicset['sel_encoder'] = ''
            logicset['sel_profile'] = ''
            logicset['sel_server'] = ''
            if last_encoders:
                for serverset in last_encoders:
                    if serverset['server'] == logic.absolute_url(relative=1):
                        logicset['sel_encoder'] = serverset['encoder']
                        logicset['sel_profile'] = serverset['profile']
                        try:
                            logicset['sel_server'] = serverset['ondemand_server']
                        except:
                            pass
            servers.append(logicset)

return servers
