## Script (Python) "startwindows"
##parameters=
##title=

req = context.REQUEST
event = context
memtool = context.portal_membership
member = memtool.getAuthenticatedMember()
mempass = context.getMemberPass(member)
username = member.getUserName()
medianet = context.portal_mediamanager.getMedianetFor(context)

status_msg = 'Not+set'

if not event.meta_type == 'Media Manager Live Event':
    raise 'Attribute Error', 'This is not a live event'

if req['action_name'] == 'start_all' or req['action_name'] == 'stop_all':
    encoders = req['encoders']
    serverpaths = req['serverpath']
    profiles = req['profiles']
    ondemandservers = req['ondemand_server']
    status_msg = 'Encoding+all+encoders'
else:
    objectindex = int(req['action_value'])
    encoders = []
    serverpaths = []
    profiles = []
    ondemandservers = []
    encoders.append(req['encoders'][objectindex])
    serverpaths.append(req['serverpath'][objectindex])
    profiles.append(req['profiles'][objectindex])
    ondemandservers.append(req['ondemand_server'][objectindex])
    status_msg = 'Encoding+one+encoder'

if req['action_name'] == 'start_all' or req['action_name'] == 'single_start':
    file = event.listFileObjects()[0]
    filename = file.filename
    index = 0
    status_msg = 'Start+encoding'
    for logicpath in serverpaths:
        logic = context.restrictedTraverse(logicpath)
        endserver = context.restrictedTraverse(ondemandservers[index])
        ext = ''
        ext = endserver.getFileExtension()
        filename_ext = "%s%s" % (filename, ext)
        filepath = file.absolute_url()
        profile = profiles[index]
        profileset = medianet.getEncoderProfileById(profile)
        if profileset['use_video']:
            use_video = 'true'
        else:
            use_video = 'false'
        if profileset['use_script']:
            use_script = 'true'
        else:
            use_script = 'false'

        encoderpath = encoders[index]
        encoder = context.restrictedTraverse(encoderpath)
        endserverpath = endserver.absolute_url(relative=1)
        par = {'title': event.title
            , 'author': event.author
            , 'copyright': event.Rights()
            , 'description': event.description
            , 'server_filename': filename_ext
            , 'wmedia-profile': profile
            , 'wmedia-profile-audio': 'true'
            , 'wmedia-profile-video': use_video
            , 'wmedia-profile-script': use_script
            , 'uploader-wait': '10000'
            , 'uploader-delete': 'false'
            , 'uploader-destination': '%s?endserverpath=%s' % (filepath, endserverpath)
            , 'uploader-username': username
            , 'uploader-password': mempass
            , 'uploader-realm': 'Zope'
            }
        encoder.start(par)
        #if index == 0:
        time = str(DateTime().strftime('%H:%M:%S'))
        #logicobj = file.getLogic(logicpath)
        #logicobj.setEncoderStart(time)
        file.editFile(logicid=ondemandservers[index], encstart=time)
        #file.setEncoderStart(time)
        status_msg = 'Setting+encoder+start'
        """
        else:
            today = str(DateTime().strftime('%Y/%m/%d'))
            filetime = str(file.encoder_start)
            todaystr = str(today + ' ' + filetime)
            encstart = DateTime(todaystr).millis()
            millitime = DateTime().millis()
            differ = millitime - encstart
            logicobj = file.getLogic(logicpath)
            logicobj.setTime(differ)
            status_msg = 'Setting+offset'
        """
        status_msg = 'Encoder(s)+started'
        index = index + 1
        #file.adjustEncoderTimes()

if req['action_name'] == 'stop_all' or req['action_name'] == 'single_stop':
    for encoderpath in encoders:
        encoder = context.restrictedTraverse(encoderpath)
        encoder.stop()
        status_msg = 'Encoder(s)+stopped'

if encoders and profiles:
    last_encoders = []
    index = 0
    for encoder in encoders:
        encset = {}
        encset['encoder'] = encoder
        encset['profile'] = profiles[index]
        encset['server'] = serverpaths[index]
        encset['ondemand_server'] = ondemandservers[index]
        index = index + 1
        last_encoders.append(encset)
    event.setLastEncoder(last_encoders)

req.RESPONSE.redirect("%s/streamwindows_form?portal_status_message=%s" % (context.absolute_url(), status_msg))
